/*
 * Copyright (c) 2016-2017, Adam <Adam@sigterm.info>
 * Copyright (c) 2018, Tomas Slusny <slusnucky@gmail.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package net.runelite.client.rs;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.util.Objects;

import okhttp3.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ClientConfigLoader {
	private static final Logger logger = LoggerFactory.getLogger(ClientConfigLoader.class);

	private final OkHttpClient okHttpClient;

	public ClientConfigLoader(OkHttpClient okHttpClient) {
		this.okHttpClient = okHttpClient;
	}

	public RSConfig fetch(HttpUrl url) throws IOException {
		final Request request = new Request.Builder()
				.url(url)
				.cacheControl(new CacheControl.Builder().noStore().build())
				.build();

		logger.info("Fetching configuration from URL: {}", url);

		final RSConfig config = new RSConfig();

		try (Response response = okHttpClient.newCall(request).execute()) {
			if (!response.isSuccessful()) {
				String errorMessage = "Unsuccessful response: " + response.message();
				logger.error(errorMessage);
				throw new IOException(errorMessage);
			}

			String str;
			final BufferedReader in = new BufferedReader(new InputStreamReader(Objects.requireNonNull(response.body()).byteStream(), StandardCharsets.UTF_8));
			while ((str = in.readLine()) != null) {
				logger.debug("Received line: {}", str);

				int idx = str.indexOf('=');

				if (idx == -1) {
					logger.debug("Skipping line as it doesn't contain '=': {}", str);
					continue;
				}

				String key = str.substring(0, idx);
				String value = str.substring(idx + 1);

				switch (key) {
					case "param":
						str = str.substring(idx + 1);
						idx = str.indexOf('=');
						key = str.substring(0, idx);

						config.getAppletProperties().put(key, str.substring(idx + 1));
						break;
					case "msg":
						// ignore not needed.
						break;
					default:
						config.getClassLoaderProperties().put(key, value);
						break;
				}
			}
		} catch (IOException e) {
			logger.info("Exception occurred while fetching configuration", e);
			throw e;
		}

		logger.info("Configuration fetched successfully from URL: {}", url);
		return config;
	}
	}
